<?php
// ----------------------------------------------------------------------
// Fast Click SQL - Advanced Clicks Counter System
// Copyright (c) 2003-2006 by Dmitry Ignatyev (ftrainsoft@mail.ru)
// http://www.FTRSoft.com/
// ----------------------------------------------------------------------
// Original Author of file: Dmitry Ignatyev
// ----------------------------------------------------------------------

@ignore_user_abort(true);
@Error_Reporting(E_ALL & ~E_NOTICE);

$CFG['USER'] = 1;
$CFG['CDIR'] = "./common";
require($CFG['CDIR']."/error.php");
require($CFG['CDIR']."/init.php");

// Initialization
InitVars();
if($ERR['flag']) {
  err('fclick.php||initialization was failed');
  log_out();
  die('Initialization was failed. Communicate with Administrator.');
 }

//------------------
// Get Link from DB
//------------------
if(isset($_GET["id"])) $lid = $_GET["id"];
else if(isset($_GET["fid"])) $lid = $_GET["fid"];
else $lid = $_SERVER["QUERY_STRING"];

if(!$lid) {
  err('fclick.php||Link ID not specified.<br>'.
      'Referer: '.$_SERVER["HTTP_REFERRER"].'<br>Request: '.$_SERVER["REQUEST_URI"]);
  log_out();
  die('Link ID not specified. Communicate with Administrator.');
 }

$sth = $DB->query("SELECT * FROM ".$PREFIX."links WHERE Link = '".addslashes($lid)."'");
if(!$sth) {
  err('fclick.php||get link from database was failed -- '.$DB->error().
      '<br>Referer: '.$_SERVER["HTTP_REFERRER"].'<br>Request: '.$_SERVER["REQUEST_URI"]);
  log_out();
  die('Can\'t get link. Communicate with Administrator.');
 }

if(!$sth->rows()) {
  err('fclick.php||Unknow link ID: '.$lid.
      '<br>Referer: '.$_SERVER["HTTP_REFERRER"].'<br>Request: '.$_SERVER["REQUEST_URI"]);
  log_out();
  die('Unknow link ID: '.$lid.'. Communicate with Administrator.');
 }

$link = $sth->fetchrow_array();

$ip = sprintf("%u", ip2long($_SERVER['REMOTE_ADDR']));  // Get IP address

// Get information about visitor
$visitor['IP'] = $ip;
$visitor['SDate'] = $CFG['CTIME'];
$visitor['EDate'] = $CFG['CTIME'];
$visitor['Count'] = 1;

// Get Visitor (check if exists)
$sth = $DB->query("SELECT * FROM ".$PREFIX."visitors WHERE IP = ".$ip." AND EDate > ".($CFG['CTIME'] - 1800));
if(!$sth) {
  err('fclick.php||get visitor from database was failed -- '.$DB->error());
  log_out();
  Header("Location: ".$link[4]);
  exit;
 }

if(!$sth->rows()) {
  if(!$DB->insert($PREFIX."visitors", $visitor)) {
    err('fclick.php||can\'t add visitor to database -- '.$DB->error());
    log_out();
    Header("Location: ".$link[4]);
    exit;
   }

  $sth = $DB->query("SELECT LAST_INSERT_ID() FROM ".$PREFIX."visitors");
  if(!$sth) {
    err('fclick.php||can\'t get last visitor ID from database -- '.$DB->error());
    log_out();
    Header("Location: ".$link[4]);
    exit;
   }

  $visid = $sth->fetchrow_one();
 }
else {       // Update Visitor EDate
  $visid = $sth->fetchrow_one();
  $sth = $DB->query("UPDATE ".$PREFIX."visitors SET Count=Count+1, EDate=".$CFG['CTIME']." WHERE VID = ".$visid);
  if(!$sth) {
    err('fclick.php||can\'t update visitor -- '.$DB->error());
    log_out();
    Header("Location: ".$link[4]);
    exit;
   }
 }

$click['LID'] = $link[0];
$click['CID'] = $link[2];
$click['VID'] = $visid;
$click['l_date'] = $CFG['CTIME'];

if(!$DB->insert($PREFIX."stats", $click)) {
  err('fclick.php||can\'t add statistic to database -- '.$DB->error());
  log_out();
  Header("Location: ".$link[4]);
  exit;
 }
 
// Update Link Count
if(!$DB->query("UPDATE ".$PREFIX."links SET Count=Count+1 WHERE LID = ".$link[0])) {
  err('fclick.php||can\'t update link count -- '.$DB->error());
  log_out();
  Header("Location: ".$link[4]);
  exit;
 }

// Delete OLD STATS
$sth = $DB->query("DELETE FROM ".$PREFIX."stats WHERE l_date < ".($CFG['CTIME'] - $CFG['SAVESTAT'] * 86400));
if(!$sth) {
  err('fclick.php||can\'t delete old stats -- '.$DB->error());
  log_out();
  Header("Location: ".$link[4]);
  exit;
 }

$sth = $DB->query("DELETE FROM ".$PREFIX."visitors WHERE EDate < ".($CFG['CTIME'] - $CFG['SAVESTAT'] * 86400));
if(!$sth) {
  err('fclick.php||can\'t delete old visitors -- '.$DB->error());
  log_out();
 }

Header("Location: ".$link[4]);
exit;

?>