<?php
// ----------------------------------------------------------------------
// Fast Click SQL - Advanced Clicks Counter System
// Copyright (c) 2003-2006 by Dmitry Ignatyev (ftrainsoft@mail.ru)
// http://www.FTRSoft.com/
// ----------------------------------------------------------------------
// Original Author of file: Dmitry Ignatyev
// ----------------------------------------------------------------------

@ignore_user_abort(true);
@Error_Reporting(E_ALL & ~E_NOTICE);

$CFG['USER'] = 1;
$CFG['CDIR'] = "./common";
require_once($CFG['CDIR']."/error.php");
require_once($CFG['CDIR']."/init.php");

// Initialization
InitVars();
if($ERR['flag']) {
  err('show.php||initialization was failed');
  log_out();
  exit;
 }

$now_time = $CFG['dtime'];

if(isset($_GET["cid"])) $cid = $_GET["cid"];
else if(isset($_GET["id"])) $lid = $_GET["id"];
else $lid = $_SERVER["QUERY_STRING"];

if(ctype_digit($_GET["period"])) $period = $_GET["period"];
else $period = "all";

if(!isset($lid) and !isset($cid)) {
  err('show.php||ID is not specified.<br>'.
      'Referer: '.$_SERVER["HTTP_REFERRER"].'<br>Request: '.$_SERVER["REQUEST_URI"]);
  log_out();
  exit;
 }

if(isset($lid)) {
  if($period == "all") {
    // Get Link Count Total
    $sth = $DB->query("SELECT Count FROM ".$PREFIX."links WHERE Link = '".addslashes($lid)."'");
    if(!$sth) {
      err('show.php||get link from database was failed -- '.$DB->error().
          '<br>Referer: '.$_SERVER["HTTP_REFERRER"].'<br>Request: '.$_SERVER["REQUEST_URI"]);
      log_out();
      exit;
     }
    if(!$sth->rows()) {
      err('show.php||Unknown link ID: '.$lid.
          '<br>Referer: '.$_SERVER["HTTP_REFERRER"].'<br>Request: '.$_SERVER["REQUEST_URI"]);
      log_out();
      exit;
     }
    $count = $sth->fetchrow_one();
   }
  else {
    $sth = $DB->query("SELECT Count(*) FROM ".$PREFIX."stats, ".$PREFIX."links 
                      WHERE ".$PREFIX."stats.LID = ".$PREFIX."links.LID AND 
                      Link = '".addslashes($lid)."' AND l_date >= ".($now_time-86400*$period));
    if(!$sth) {
      err('show.php||get link from database was failed -- '.$DB->error().
          '<br>Referer: '.$_SERVER["HTTP_REFERRER"].'<br>Request: '.$_SERVER["REQUEST_URI"]);
      log_out();
      exit;
     }
    $count = $sth->fetchrow_one();
   }
 }
else if(isset($cid)) {
  if($cid != 'all') $query = " AND C.Cat = '".addslashes($cid)."'";
  else $query = "";

  if($period == "all") {
    $sth = $DB->query("SELECT SUM(Count) ".
                      "FROM ".$PREFIX."category C, ".$PREFIX."links L ".
                      "WHERE C.CID = L.CID".$query);
    if(!$sth) {
      err('show.php||get category stat from database was failed -- '.$DB->error().
          '<br>Referer: '.$_SERVER["HTTP_REFERRER"].'<br>Request: '.$_SERVER["REQUEST_URI"]);
      log_out();
      exit;
     }
    if(!$sth->rows() || !$sth->fetchrow_one()) {
      err('show.php||Unknown category ID: '.$cid.
          '<br>Referer: '.$_SERVER["HTTP_REFERRER"].'<br>Request: '.$_SERVER["REQUEST_URI"]);
      log_out();
      exit;
     }
    $count = $sth->fetchrow_one();
   }
  else {
    $sth = $DB->query("SELECT Count(*) FROM ".$PREFIX."stats S, ".$PREFIX."category C ".
                      "WHERE S.CID = C.CID AND l_date >= ".($now_time-86400*$period).$query);
    if(!$sth) {
      err('show.php||get category from database was failed -- '.$DB->error().
          '<br>Referer: '.$_SERVER["HTTP_REFERRER"].'<br>Request: '.$_SERVER["REQUEST_URI"]);
      log_out();
      exit;
     }
    $count = $sth->fetchrow_one();
   }
 }
else exit;

if(isset($_GET["js"])) echo "document.write('".$count."');";
else echo $count;
 
?>